<?php
/*
*	CurrencyConverter Component for Joomla! 1.5.x
* @version $Id: admin.currencyconverter.php - v1.0.2 - 2008/07/22 - D-Mack Media
* @package Joomla
* @subpackage CurrencyConverter
* @copyright (c) 2007-2010 D-Mack Media, dmackmedia.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This is free software
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

global $mainframe, $option;

// ensure user has access to this function
$my=&JFactory::getUser();
$acl=&JFactory::getACL();
if(!$my->gid == 25) {
	$mainframe->redirect( 'index2.php', _NOT_AUTH);
}

require_once( $mainframe->getPath( 'admin_html' ) );
$id 	= intval( JRequest::getvar( 'id', 0 ) );
$cid 	= JRequest::getvar( 'cid', array(0) );
if (!is_array( $cid )) {
	$cid = array(0);
}

if (isset($_GET['task'])) {
  $task = $_GET['task'];
}

switch ($task) {
	case 'Information': {
		about($option);
  	break;
  }
	case 'SaveSettings': {
		saveConfig($option);
  	break;
  }
	case "Configuration": {
		showConfig($option);
  	break;
  }
	case 'cancel': {
		showConfig($option);
  	break;
  }
	case 'back': {
		showConfig($option);
  	break;
  }
	default: {
		showConfig($option);
  	break;
	}
}

function showConfig($option) {
	global $mainframe, $option;
  include_once( JPATH_COMPONENT_ADMINISTRATOR.DS."config.currencyconverter.php" );
  include_once( JPATH_COMPONENT_ADMINISTRATOR.DS."config.currencyconverter2.php" );
	$params = array();
  $params['htmldisplay']             = $htmldisplay;
	$params['title']                   = $title;
	$params['description']             = $description;
	$params['description2']            = $description2;
	$params['description3']            = $description3;
	$params['valuelabel']              = $valuelabel;
	$params['valueinputfield']         = $valueinputfield;
	$params['fromlabel']               = $fromlabel;
  $params['fromselected']            = $fromselected;
  $params['fromselectdropdownfield'] = $fromselectdropdownfield;
	$params['tolabel']     	           = $tolabel;
  $params['toselected']              = $toselected;
	$params['toselectdropdownfield']   = $toselectdropdownfield;
	$params['submitbuttontext']        = $submitbuttontext;
	$params['result1text'] 	           = $result1text;
	$params['result2text'] 	           = $result2text;
	$params['result1']    	           = $result1;
	$params['result2'] 	               = $result2;
	$params['result'] 	               = $result;

	HTML_currencyconvert::showConfig($params, $option);
}

/* Save configuration form @param string The current GET/POST option */
function saveConfig($option) {
	global $option, $mainframe;
	$configfile = JPATH_COMPONENT_ADMINISTRATOR.DS."config.currencyconverter.php";
	@chmod ($configfile, 0777);
	$permission = @is_writable($configfile);
	if (!$permission) {
    $mainframe->redirect( 'index2.php?option=$option', 'Configuration file not writable!' );
	  break;
	}
  $title                   = addslashes(JRequest::getvar('title', 'Currency Converter', 'post', 'string',JREQUEST_ALLOWRAW));
  $description             = addslashes(JRequest::getvar('description', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $description2            = addslashes(JRequest::getvar('description2', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $description3            = addslashes(JRequest::getvar('description3', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $valuelabel              = addslashes(JRequest::getvar('valuelabel', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $fromlabel               = addslashes(JRequest::getvar('fromlabel', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $fromselected            = addslashes(JRequest::getvar('fromselected', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $tolabel                 = addslashes(JRequest::getvar('tolabel', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $toselected              = addslashes(JRequest::getvar('toselected', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $submitbuttontext        = addslashes(JRequest::getvar('submitbuttontext', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $result1text             = addslashes(JRequest::getvar('result1text', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $result2text             = addslashes(JRequest::getvar('result2text', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $result1                 = addslashes(JRequest::getvar('result1', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $result2                 = addslashes(JRequest::getvar('result2', '', 'post', 'string',JREQUEST_ALLOWRAW));
  $result                  = addslashes(JRequest::getvar('result', '', 'post', 'string',JREQUEST_ALLOWRAW));

  $valueinputfield         = addslashes("<input name='val' type='text' size='10' />");

  if (JRequest::getVar( 'restore_hidden' ) != 'Restore') {
    $htmldisplay           = addslashes(JRequest::getVar( 'htmldisplay','HTML Display', 'post', 'string',JREQUEST_ALLOWRAW));
  } else {
    $htmldisplay = addslashes('
<h1 class="componentheading">
  {title}
</h1>
{description}
<hr />
{description2}
<br />
{description3}
<hr />
<div align="center">
  <center>
    <form name="converter" action="#">
      <table border="0" cellpadding="2" cellspacing="2" width="50%">
        <tr>
          <td width="98" align="right">
            {valuelabel}
          </td>
          <td align="left">
            {valueinputfield}
          </td>
        </tr>
        <tr>
          <td align="right">
            {fromlabel}
          </td>
          <td align="left">
            {fromselectdropdownfield}
          </td>
        </tr>
        <tr>
          <td align="right">
            {tolabel}
          </td>
          <td align="left">
            {toselectdropdownfield}
          </td>
        </tr>
        <tr>
          <td colspan="2">
            <input name="submit" type="button" value="{submitbuttontext}" onclick="showDataInput()" />
          </td>
        </tr>
      </table>
      {result1}
      {result2}
      <hr />
        {result}
      <hr />
    </form>
  </center>
</div>
');
  }
  $config =
  '<?php
  $title                   = "'.$title.'";
  $description             = "'.$description.'";
  $description2            = "'.$description2.'";
  $description3            = "'.$description3.'";
  $valuelabel              = "'.$valuelabel.'";
  $fromlabel               = "'.$fromlabel.'";
  $fromselected            = "'.$fromselected.'";
  $tolabel                 = "'.$tolabel.'";
  $toselected              = "'.$toselected.'";
  $submitbuttontext        = "'.$submitbuttontext.'";
  $valueinputfield         = "'.$valueinputfield.'";
  $result1text             = "'.$result1text.'";
  $result2text             = "'.$result2text.'";
  $result1                 = "'.$result1.'";
  $result2                 = "'.$result2.'";
  $result                  = "'.$result.'";
  $htmldisplay             = "'.$htmldisplay.'"
  ?>';
?>
<?php
  if ($fp = @fopen("$configfile", "w")) {
  	@fputs($fp, $config, strlen($config));
  	@fclose ($fp);
  }
  $mainframe->redirect( "index2.php?option=$option&task=Configuration", JText::_( 'Configuration Saved' ) );
}

function about($option) {
	global $option;
	HTML_currencyconvert::about($option);
}

?>