<?php
/**
 * Joomla! 1.5 component Simple Lists
 *
 * @author Jisse Reitsma (info@jira.nl)
 * @package SimpleLists
 * @copyright Copyright 2007
 * @license GNU Public License
 * @link http://www.jira.nl
 * @version 1.5.0.1
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Include library dependencies
jimport('joomla.filter.input');

/**
* Category Table class
*
* @package		SimpleLists
* @since 1.5.0.1
*/
class TableCategory extends JTable
{
	/**
	 * Primary Key
	 *
	 * @var int
	 */
	var $id = null;

	/**
	 * @var int
	 */
	var $parent_id = null;

	/**
	 * @var string
	 */
	var $title = null;

	/**
	 * @var string
	 */
	var $name = null;

	/**
	 * @var string
	 */
	var $alias = null;

	/**
	 * @var string
	 */
	var $image = null;

	/**
	 * @var string
	 */
	var $section = null;

	/**
	 * @var string
	 */
	var $image_position = null;

	/**
	 * @var string
	 */
	var $description = null;

	/**
	 * @var int
	 */
	var $published = 0;

	/**
	 * @var int
	 */
	var $checked_out = 0;

	/**
	 * @var int
	 */
	var $checked_out_time = 0;

	/**
	 * @var string
	 */
	var $editor = null;

	/**
	 * @var int
	 */
	var $ordering = 0;

	/**
	 * @var int
	 */
	var $access = 0;

	/**
	 * @var int
	 */
	var $count = 0;

	/**
	 * @var int
	 */
	var $params = null;

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.0
	 */
	function __construct(& $db) {
		parent::__construct('#__categories', 'id', $db);
	}

	/**
	* Overloaded bind function
	*
	* @acces public
	* @param array $hash named array
	* @return null|string	null is operation was satisfactory, otherwise returns an error
	* @see JTable:bind
	* @since 1.5
	*/
	function bind($array, $ignore = '')
	{
        if( empty($array['alias'])) {
            $array['alias'] = JFilterOutput::stringURLSafe($array['title']);
        }

		if (key_exists( 'params', $array ) && is_array( $array['params'] )) {
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}

        // Allways override the section
        $array['section'] = 'com_simplelists' ;

		return parent::bind($array, $ignore);
	}

	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @access public
	 * @return boolean True on success
	 * @since 1.0
	 */
	function check()
	{

        $mainframe =& JFactory::getApplication() ;

		/** check for valid name */
		if (trim($this->title) == '') {
            $mainframe->enqueueMessage( JText::_('Please provide a valid title'), 'error' ) ;
			return false;
		}

		/** check for existing name */
		$query = 'SELECT id FROM #__categories WHERE title = '.$this->_db->Quote($this->title).' AND section = "com_simplelists" AND id != '.(int) $this->category_id;
		$this->_db->setQuery($query);

		$xid = intval($this->_db->loadResult());
		if ($xid && $xid != intval($this->id)) {
            $mainframe->enqueueMessage( JText::_('Duplicate title is not allowed'), 'error' ) ;
			return false;
		}

		jimport('joomla.filter.output');

		return true;
	}
}
