<?php
/**
 * Joomla! 1.5 component Simple Lists
 *
 * @author Jisse Reitsma (info@jira.nl)
 * @package SimpleLists
 * @copyright Copyright 2007
 * @license GNU Public License
 * @link http://www.jira.nl
 * @version 1.5.0.1
 */

// Check to ensure this file is included in Joomla!  
defined('_JEXEC') or die();

jimport('joomla.application.component.view');
jimport('joomla.html.pane');
jimport('joomla.filesystem.file');
jimport('joomla.filter.output');

/**
 * HTML View class for the Simplelists component
 *
 * @static
 * @package	Simplelists
 * @since 1.0
 */
class SimplelistsViewCategory extends JView
{
	function display($tpl = null)
	{
		global $option;

        $application =& JFactory::getApplication() ;
		$db	=& JFactory::getDBO();
		$uri =& JFactory::getURI();
		$user =& JFactory::getUser();
        $pane = & JPane::getInstance('sliders');
		$model	=& $this->getModel( 'category' );

		$lists = array();

		// get the category
		$category =& $this->get('data');
		$isNew = ($category->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The category' ), $category->title );
			$application->redirect( 'index.php?option='. $option, $msg );
		}

		// Edit or Create
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			// initialise new record
			$category->published = 1;
			$category->approved = 1;
			$category->order = 0;
		}

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__categories'
			. ' WHERE section = "com_simplelists"' 
			. ' ORDER BY ordering';

		$lists['ordering'] = JHTML::_('list.specificordering',  $category, $category->id, $query, 1 );
        $lists['access'] = JHTML::_('list.accesslevel', $category );
		$lists['parent_id'] = JHTML::_('list.category', 'parent_id', $option, $category->parent_id );
		$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $category->published );
        $lists['image_position'] = JHTML::_('list.positions', 'image_position', $category->image_position ? $category->image_position : 'left', NULL, 0, 0 );

        // image selection
        $directory = 'images'.DS.'simplelists' ;
        $category->image_directory = $directory ;
        if( SimplelistsHelper::createDir( JPATH_SITE.DS.$directory )) {
            $lists['pictures'] = JHTML::_('list.images',  'image', $category->image, 'onchange="changeDisplayImage();"', $directory );
        } else {
            $lists['pictures'] = '' ;
        }

		//clean category data
		JFilterOutput::objectHTMLSafe( $category, ENT_QUOTES, 'text' );

		//$params = JComponentHelper::getParams ('com_simplelists');
        $params = new JParameter( '', JPATH_COMPONENT.DS.'models'.DS.'category.xml');

		$this->assignRef('lists', $lists);
		$this->assignRef('category', $category);
		$this->assignRef('params', $params);
        $this->assignRef('pane', $pane);

		parent::display($tpl);
	}
}
