<?php
/**
 * Joomla! 1.5 component Simple Lists
 *
 * @author Jisse Reitsma (info@jira.nl)
 * @package SimpleLists
 * @copyright Copyright 2007
 * @license GNU Public License
 * @link http://www.jira.nl
 * @version 1.5.0.1
 */

// Check to ensure this file is included in Joomla! 
defined('_JEXEC') or die();

jimport('joomla.application.component.view');
jimport('joomla.filter.output');

/**
 * HTML View class for the Simplelists component
 *
 * @static
 * @package	Simplelists
 * @since 1.0
 */
class SimplelistsViewItem extends JView
{
	function display($tpl = null)
	{
        // Include the global $option
		global $option;

        // Fetch common objects from JFactory
        $application =& JFactory::getApplication() ;
		$db	=& JFactory::getDBO();
		$user =& JFactory::getUser();
		$model =& $this->getModel( 'item' );
        $document =& JFactory::getDocument();

        // Initialize $lists
		$lists = array();

        // Give a warning if no categories are configured
        SimplelistsHelper::checkCategories() ;

		// Get the item
		$item =& $this->get('data');
		$isNew		= ($item->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The list' ), $item->title );
			$application->redirect( 'index.php?option='. $option, $msg );
		}

		// Edit or Create?
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			// initialise new record
			$item->published = 1;
			$item->approved 	= 1;
			$item->order 	= 0;
		}

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__simplelists'
			. ' ORDER BY ordering';

        // common lists
		$lists['categories'] = SimplelistsHelper::getCategoryOptions( $item->id );
		$lists['ordering'] = JHTML::_('list.specificordering',  $item, $item->id, $query, 1 );
		$lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $item->published );
                
        $directory = 'images'.DS.'simplelists' ;
        $item->image_directory = $directory ;

        // link settings
        $modal = array() ;
        $modal['article'] = 'index.php?option=com_content&task=element&tmpl=component' ;
        $modal['image'] = 'index.php?option=com_simplelists&view=images&tmpl=component' ;
        $modal['file'] = 'index.php?option=com_simplelists&view=images&tmpl=component&e_name=text' ;

        // create the article modal-selections
		JHTML::_('script', 'item.js', 'administrator/components/com_simplelists/js/');

		// clean simplelist data
		JFilterOutput::objectHTMLSafe( $item, ENT_QUOTES, 'text' );

		$file 	= JPATH_COMPONENT.DS.'models'.DS.'item.xml';
		$params = new JParameter( $item->params, $file );


		$this->assignRef('lists', $lists);
		$this->assignRef('modal', $modal);
		$this->assignRef('item', $item);
		$this->assignRef('params', $params);

		parent::display($tpl);
	}
}
