<?php
/**
 * Joomla! 1.5 component Simple Lists
 *
 * @author Jisse Reitsma (info@jira.nl)
 * @package SimpleLists
 * @copyright Copyright 2007
 * @license GNU Public License
 * @link http://www.jira.nl
 * @version 1.5.0.1
 */

// Check to ensure this file is included in Joomla!  defined('_JEXEC') or die();
jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Simplelists component
 *
 * @static
 * @package	Simplelists
 * @since 1.0
 */
class SimplelistsViewItems extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
        $option = $option.'-items' ;

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();

        SimplelistsHelper::checkCategories() ;

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',		'',				'word' );
		$filter_category_id		= $mainframe->getUserStateFromRequest( $option.'filter_category_id',		'filter_category_id',		0,				'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		// Get data from the model
		$items		= & $this->get( 'Data');
		$total		= & $this->get( 'Total');
		$pagination = & $this->get( 'Pagination' );

        // Prepare data for each simplelists item
        foreach( $items as $i => $item ) {
            $item->categories = SimplelistsHelper::getCategories( $item->id );
            $item->edit_link = JRoute::_( 'index.php?option=com_simplelists&view=item&task=edit&cid[]='. $item->id );
            $items[$i] = $item ;
        }

		// build list of categories
		$javascript 	= 'onchange="document.adminForm.submit();"';
		$lists['category_id'] = JHTML::_('list.category',  'filter_category_id', 'com_simplelists', intval( $filter_category_id ), $javascript );

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search']= $search;

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);
		
		parent::display($tpl);
	}
}
