<?php
/**
 * Joomla! 1.5 component Simple Lists
 *
 * @author Jisse Reitsma (info@jira.nl)
 * @package SimpleLists
 * @copyright Copyright 2007
 * @license GNU Public License
 * @link http://www.jira.nl
 * @version 1.5.0.1
 */

// Check to ensure this file is included in Joomla!  defined('_JEXEC') or die();
jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Simplelists component
 *
 * @static
 * @package	Simplelists
 * @since 1.0
 */
class SimplelistsViewSimplelist extends JView
{
	function display($tpl = null)
	{
		global $mainframe;

		if($this->getLayout() == 'form') {
			$this->_displayForm( $tpl );
			return;
		}

		//get the simplelist
		$simplelist =& $this->get('data');

		if ($simplelist->url) {
			// redirects to url if matching id found
			$mainframe->redirect($simplelist->url);
		}

		parent::display($tpl);
	}

	function _displayForm($tpl)
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri 	=& JFactory::getURI();
		$user 	=& JFactory::getUser();
		$model	=& $this->getModel( 'simplelist' );

		$lists = array();

        SimplelistsHelper::checkCategories() ;

		//get the simplelist
		$simplelist	=& $this->get('data');
		$isNew		= ($simplelist->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The list' ), $simplelist->title );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		// Edit or Create?
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			// initialise new record
			$simplelist->published = 1;
			$simplelist->approved 	= 1;
			$simplelist->order 	= 0;
			$simplelist->catid 	= JRequest::getVar( 'catid', 0, 'post', 'int' );
		}

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__simplelists'
			. ' WHERE catid = ' . (int) $simplelist->catid
			. ' ORDER BY ordering';

		$lists['ordering'] = JHTML::_('list.specificordering',  $simplelist, $simplelist->id, $query, 1 );
		$lists['catid'] = JHTML::_('list.category',  'catid', $option, intval( $simplelist->catid ) );
		$lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $simplelist->published );
                

        $directory = 'images'.DS.'simplelists' ;
        if( SimplelistsHelper::createDir( JPATH_SITE.DS.$directory )) {
            $lists['pictures'] = JHTML::_('list.images',  'picture', $simplelist->picture, 'onchange="changeDisplayImage();"', $directory );
        } else {
            $lists['pictures'] = '' ;
        }
        $simplelist->image_directory = $directory ;

		//clean simplelist data
		jimport('joomla.filter.output');
		JFilterOutput::objectHTMLSafe( $simplelist, ENT_QUOTES, 'text' );

		$file 	= JPATH_COMPONENT.DS.'models'.DS.'simplelist.xml';
		$params = new JParameter( $simplelist->params, $file );

		$this->assignRef('lists',		$lists);
		$this->assignRef('simplelist',		$simplelist);
		$this->assignRef('params',		$params);

		parent::display($tpl);
	}
}
?>
