<?php    
class SimplelistsViewHelper extends JView
{
    function getUrl( $category_id = 0, $category_alias = '', $layout = '', $item_id = null )
    {
        $url = 'index.php?option=com_simplelists&view=simplelist' ;

        if( !empty($layout)) {
            $url .= '&layout='.$layout ;
        }

        $slug = (int)$category_id ;
        if( $category_alias != '' ) {
            $slug .= ':'.$category_alias ;
        }
        $url .= '&category_id='.$slug ;

        $url = JRoute::_( $url );

        if( $item_id > 0 ) {
            $url .= '#item' . (int)$item_id ;
        }

        return $url;
    }

    /*
     * An override of the original JView-function to allow template-files across multiple layouts
     */
    function loadTemplate($file = null)
    {
        // clear prior output
        $output = null;

        // clean the file name
        $file = preg_replace('/[^A-Z0-9_\.-]/i', '', $file);

        // load the template script
        jimport('joomla.filesystem.path');
        $filetofind = $this->_createFileName('template', array('name' => $file));
        $template = JPath::find($this->_path['template'], $filetofind);

        if ($template != false)
        {
            // unset so as not to introduce into template scope
            unset($file);

            // never allow a 'this' property
            if (isset($this->this)) {
                unset($this->this);
            }

            // start capturing output into a buffer
            ob_start();
            // include the requested template filename in the local scope
            // (this will execute the view logic).
            include $template;

            // done with the requested template; get the buffer and
            // clear it.
            $output = ob_get_contents();
            ob_end_clean();

            return $output;
        }
        else {
            return null;
        }
    }
}
