<?php
/**
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');

require_once JPATH_COMPONENT.DS.'helpers'.DS.'helper.php' ;

/**
 * HTML View class for the SimpleLists component
 *
 * @static
 * @package		SimpleLists
 * @since 1.0
 */
class SimplelistsViewSimplelist extends JView
{
	function display($tpl = null)
	{
        $document =& JFactory::getDocument();

        // layout parameters
        $params = &JComponentHelper::getParams( 'com_simplelists' );

        $show_category_title            = $params->get('show_category_title');
        $show_category_description      = $params->get('show_category_description');
        $show_category_image            = $params->get('show_category_image');
        $show_category_parent           = $params->get('show_category_parent');
        $show_category_childs           = $params->get('show_category_childs');
        $show_item_title                = $params->get('show_item_title');
        $show_item_text                 = $params->get('show_item_text');
        $show_item_image                = $params->get('show_item_image');
        $image_link                     = $params->get('image_link');
        $title_link                     = $params->get('title_link');
        $page_title                     = $params->get('page_title');
        $show_page_title                = $params->get('show_page_title');
        $use_pagination                 = $params->get('use_pagination');
        $limit                          = $params->get('limit');
        $show_header_modules            = $params->get('show_header_modules');
        $show_footer_modules            = $params->get('show_footer_modules');
        $show_alpha_index               = $params->get('show_alpha_index');
        $link_class                     = $params->get('link_class', '');

        // override certain options for specific layouts
        $layout = $this->getLayout() ;

        // load the model
        $model =& $this->getModel();

        // get the category from our model
        $category = $model->getCategory() ;

        // set the page title
        if( $show_page_title == 1 && $page_title != '' ) {
            $document->setTitle( $page_title );
            $category->title = $page_title ;
        } else {
            $document->setTitle( $category->title );
        }

        // enable pagination
        if( $use_pagination ) {
            // customize pagination
            if( $limit > 0 ) {
                $model->setLimit( $limit ) ;
            }

            // get the simple list from our model
            $simplelist = $model->getData() ;

            // get the pagination
            $pagination = $model->getPagination() ;
            $this->assignRef( 'pagination', $pagination );

        } else {

            // get the simple list from our model without pagination
            $simplelist = $model->getData() ;

        }

        // get the simple list from our model
        $simplelist = $model->getData() ;

        // run the category content through Content Plugins
        if( $show_category_description && $category->description ) {
            $category->text = $category->description;
            $dispatcher =& JDispatcher::getInstance();
            JPluginHelper::importPlugin( 'content' );
            $results = $dispatcher->trigger('onPrepareContent', array ( &$category, array(), 0));
            $category->description = $category->text; 
            $category->text = null ;
        }

        // prepare the category image
        if( $show_category_image && $category->image ) {
            $cparams = JComponentHelper::getParams ('com_media');
            $image = $cparams->get('image_path') . '/' . $category->image ;
            $category->image = JHTML::image( $image, $category->title, array( 'align' => $category->image_position));
        } else {
            $show_category_image = 0 ;
        }

        // prepare the category URL
        if( $show_category_parent && !empty( $category->parent )) {
            $id = $category->parent->id ;
            $category->parent->link = SimplelistsViewHelper::getUrl( $id, '', $layout );
        }
        if( $show_category_childs && !empty( $category->childs )) {
            foreach( $category->childs as $child ) { 
                $child->link = SimplelistsViewHelper::getUrl( $child->id, '', $layout );
            }
        }

        if( is_array($simplelist) && count( $simplelist ) > 0 ) {

            // loop through the list to set things right
            foreach( $simplelist as $id => $item ) {

                // run the content through Content Plugins
                if( $show_item_title ) {
                    $dispatcher =& JDispatcher::getInstance();
                    JPluginHelper::importPlugin( 'content' );
                    $results = $dispatcher->trigger('onPrepareContent', array ( &$item, array(), 0));
                } else {
                    $item->text = '' ;
                }

                // prepare the URL
                $item->url = SimplelistsHelper::getUrl( $item->link_type, $item->link );

                // please note that the items parameters are different from the simplelists parameters
                $item->target = false ;
                $item->readmore = false ;
                $item->picture_alignment = false ;
                if( $item->params ) {
                    // convert our parameter string to a JParameter object
                    $item->params = new JParameter( $item->params ) ;

                    // create a simple target-string
                    if( $item->params->get( 'target' ) == 1 ) {
                        $item->target = ' target="_blank"' ;
                    } elseif( $item->params->get( 'target' ) == 2 ) {
                        $item->target = ' onclick="javascript: window.open(\''. $item->url .'\', \'\', \'toolbar=no,location=no,status=no,' 
                            . 'menubar=no,scrollbars=yes,resizable=yes,width=780,height=550\'); return false"' ;
                    }

                    // set the readmore link for this item
                    if( $item->params->get( 'readmore' ) == 1 && $item->url ) {
                        $readmore_text = $item->params->get( 'readmore_text', JText::_( 'Read more' )) ;
                        $readmore_css = trim( 'readon ' . $item->params->get( 'readmore_class', '' ));
                        $item->readmore = JHTML::link( $item->url, $readmore_text, 'title="'.$item->title.'" class="'.$readmore_css.'"'.$item->target );
                    }

                    // set the image-alignment for this item
                    if( $item->params->get( 'picture_alignment' ) != '' && $layout != 'picture' ) {
                        $item->picture_alignment = ' align="' . $item->params->get( 'picture_alignment' ) . '"';
                    } else {
                        $item->picture_alignment = 'test' ;
                    }
                }

                // prepare the image
                if( $show_item_image && !empty( $item->picture )) {
                    $item->picture = "images/simplelists/" . $item->picture ;
                    $item->picture = JHTML::image( $item->picture, $item->title, 'title="'.$item->title.'" class="simplelists"'.$item->picture_alignment);
                    if( $image_link && !empty( $item->url )) {
                        $item_link_class = $item->params->get( 'link_class', $link_class );
                        if(!empty( $item_link_class )) {
                            $item_link_class = ' class="'.$item_link_class.'"' ;
                        }
                        $item->picture = JHTML::link( $item->url, $item->picture, 'title="'.$item->title.'"'.$item->target.$item_link_class );
                    }
                } else {
                    $item->picture = null ;
                }

                // prepare the title
                if( $show_item_title ) {
                    if( $title_link && !empty( $item->url )) {
                        $item->title = JHTML::link( $item->url, $item->title, $item->target );
                    }
                } else {
                    $item->title = null ;
                }

                // save the item in the array
                $simplelist[$id] = $item ;
            }
        }

        $u =& JFactory::getURI();
        $url = $u->toString();

        $this->assignRef( 'simplelist', $simplelist );
        $this->assignRef( 'category', $category );
        $this->assignRef( 'show_category_title', $show_category_title );
        $this->assignRef( 'show_category_description', $show_category_description );
        $this->assignRef( 'show_category_image', $show_category_image );
        $this->assignRef( 'show_category_parent', $show_category_parent );
        $this->assignRef( 'show_category_childs', $show_category_childs );
        $this->assignRef( 'show_item_title', $show_item_title );
        $this->assignRef( 'show_item_text', $show_item_text );
        $this->assignRef( 'show_item_image', $show_item_image );
        $this->assignRef( 'image_link', $image_link );
        $this->assignRef( 'title_link', $title_link );
        $this->assignRef( 'use_pagination', $use_pagination );
        $this->assignRef( 'show_header_modules', $show_header_modules );
        $this->assignRef( 'show_footer_modules', $show_footer_modules );
        $this->assignRef( 'show_alpha_index', $show_alpha_index );
        $this->assignRef( 'url', $url);

		parent::display($tpl);
	}
}
